---
product: "AG Charts"
title: "Animation"
description: "Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out."
enterprise: true
framework: javascript
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/touch/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Animation

## Initial Load

Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out.

#### Initial Load

```ts
import {
  AgCartesianChartOptions,
  AgCartesianSeriesTooltipRendererParams,
  AgChartOptions,
  AgCharts,
  AgPolarChartOptions,
  AgTooltipRendererResult,
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { DataType, getData } from "./data";

const numFormatter = new Intl.NumberFormat("en-US");
const tooltip = {
  renderer: ({
    datum,
    yKey,
    yName,
  }: AgCartesianSeriesTooltipRendererParams<DataType>): AgTooltipRendererResult => {
    return {
      data: [
        { label: yName!, value: numFormatter.format(Number(datum[yKey])) },
      ],
    };
  },
};
const barOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "bar",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const lineOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "line",
      xKey: "station",
      yKey: "early",
      yName: "Early",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const areaOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "area",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const donutOptions: AgPolarChartOptions<DataType> = {
  series: [
    {
      type: "pie",
      title: {
        text: "Morning Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "morningPeak",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Afternoon Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "afternoonPeak",
      showInLegend: false,
    },
  ],
};
ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const options:
  | AgCartesianChartOptions<DataType>
  | AgPolarChartOptions<DataType> = {
  data: getData(),
  animation: {
    enabled: true,
  },
  ...barOptions,
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function seriesTypeChange(event: Event) {
  const value = (event.target as HTMLInputElement).value;
  const seriesOptions = {
    bar: barOptions,
    line: lineOptions,
    area: areaOptions,
    donut: donutOptions,
  }[value]!;
  options.series = seriesOptions.series;
  options.axes = seriesOptions.axes;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).seriesTypeChange = seriesTypeChange;
}
```

[Live example: Initial Load](https://www.ag-grid.com/charts/archive/14.2.0/typescript/animation/examples/initial-load/)

## Data Updates

A data update animation is split into three sequential phases — remove, update then add, which can be observed for different series types in this example:

#### Line Series Data Updates

```ts
import {
  AgCartesianChartOptions,
  AgChartOptions,
  AgCharts,
  AgPolarChartOptions,
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { getData, random } from "./data";

let start = [120, 150, 130, 140, 80];
let variance = 20;
let offset = 0;
let length = 8;
let seed = 1234;
const barOptions: AgCartesianChartOptions = {
  series: [
    {
      type: "bar",
      xKey: "year",
      yKey: "one",
      yName: "One",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "two",
      yName: "Two",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "three",
      yName: "Three",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "four",
      yName: "Four",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "five",
      yName: "Five",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        autoRotate: false,
      },
    },
  },
};
const lineOptions: AgCartesianChartOptions = {
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "one",
      yName: "One",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "two",
      yName: "Two",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "three",
      yName: "Three",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "four",
      yName: "Four",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "five",
      yName: "Five",
    },
  ],
  axes: {
    x: {
      type: "number",
      nice: false,
      label: {
        autoRotate: false,
      },
    },
  },
};
const areaOptions: AgCartesianChartOptions = {
  series: [
    {
      type: "area",
      xKey: "year",
      yKey: "one",
      yName: "One",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "two",
      yName: "Two",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "three",
      yName: "Three",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "four",
      yName: "Four",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "five",
      yName: "Five",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "number",
      nice: false,
      label: {
        autoRotate: false,
      },
    },
  },
};
const donutOptions: AgPolarChartOptions = {
  series: [
    {
      type: "pie",
      title: {
        text: "One",
      },
      calloutLabelKey: "year",
      legendItemKey: "year",
      angleKey: "one",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Two",
      },
      calloutLabelKey: "year",
      legendItemKey: "year",
      angleKey: "two",
      showInLegend: false,
    },
  ],
};
function getGeneratedData() {
  return getData(start, variance, offset, length, seed);
}
ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions | AgPolarChartOptions = {
  animation: {
    enabled: true,
  },
  data: getGeneratedData(),
  ...barOptions,
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function seriesTypeChange(event: Event) {
  const seriesType = (event.target as HTMLInputElement).value as
    | "bar"
    | "line"
    | "area"
    | "donut";
  offset = 0;
  seed = 1234;
  switch (seriesType) {
    case "bar":
      variance = 20;
      length = 8;
      options.series = barOptions.series;
      options.axes = barOptions.axes;
      break;
    case "line":
      variance = 4;
      length = 30;
      options.series = lineOptions.series;
      options.axes = lineOptions.axes;
      break;
    case "area":
      variance = 20;
      length = 30;
      options.series = areaOptions.series;
      options.axes = areaOptions.axes;
      break;
    case "donut":
      variance = 30;
      length = 6;
      options.series = donutOptions.series;
      options.axes = donutOptions.axes;
      break;
  }
  options.data = getGeneratedData();

  chart.update(options);
}

function add() {
  offset++;
  length++;
  options.data = getGeneratedData();

  chart.update(options);
}

function remove() {
  if (options.series?.[0].type === "pie") offset--;
  length = Math.max(0, length - 1);
  options.data = getGeneratedData();

  chart.update(options);
}

function update() {
  seed = Math.floor(random() * 1000);
  options.data = getGeneratedData();

  chart.update(options);
}

function addRemoveUpdate() {
  if (options.series?.[0].type === "pie") offset--;
  if (options.series?.[0].type !== "pie") offset++;
  seed = Math.floor(random() * 1000);
  options.data = getGeneratedData();

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).seriesTypeChange = seriesTypeChange;
  (<any>window).add = add;
  (<any>window).remove = remove;
  (<any>window).update = update;
  (<any>window).addRemoveUpdate = addRemoveUpdate;
}
```

[Live example: Line Series Data Updates](https://www.ag-grid.com/charts/archive/14.2.0/typescript/animation/examples/data-updates/)

## Duration

You can use the `duration` option to specify the length of all animations in milliseconds.

For an initial load, this is simply the duration of the whole animation.

For a data update, the duration is the total time of all three animation phases together — remove, update then add.

```js
{
    animation: {
        duration: 500,
    },
}
```

In this example, click a duration then change the series type to see the initial load animation.

#### Duration

```ts
import {
  AgCartesianChartOptions,
  AgCartesianSeriesTooltipRendererParams,
  AgChartOptions,
  AgCharts,
  AgPolarChartOptions,
  AgTooltipRendererResult,
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { DataType, getData } from "./data";

const numFormatter = new Intl.NumberFormat("en-US");
const tooltip = {
  renderer: ({
    datum,
    yKey,
    yName,
  }: AgCartesianSeriesTooltipRendererParams<DataType>): AgTooltipRendererResult => {
    return {
      data: [
        { label: yName!, value: numFormatter.format(Number(datum[yKey])) },
      ],
    };
  },
};
const barOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "bar",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const lineOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "line",
      xKey: "station",
      yKey: "early",
      yName: "Early",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const areaOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "area",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const donutOptions: AgPolarChartOptions<DataType> = {
  series: [
    {
      type: "pie",
      title: {
        text: "Morning Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "morningPeak",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Afternoon Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "afternoonPeak",
      showInLegend: false,
    },
  ],
};
ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const options:
  | AgCartesianChartOptions<DataType>
  | AgPolarChartOptions<DataType> = {
  data: getData(),
  animation: {
    enabled: true,
    duration: 500,
  },
  ...barOptions,
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function seriesTypeChange(event: Event) {
  const value = (event.target as HTMLInputElement).value;
  switch (value) {
    case "bar":
      options.series = barOptions.series;
      options.axes = barOptions.axes;
      break;
    case "line":
      options.series = lineOptions.series;
      options.axes = lineOptions.axes;
      break;
    case "area":
      options.series = areaOptions.series;
      options.axes = areaOptions.axes;
      break;
    case "donut":
      options.series = donutOptions.series;
      options.axes = donutOptions.axes;
      break;
  }

  chart.update(options);
}

function durationChange(event: Event) {
  const duration = Number((event.target as HTMLInputElement).value);
  options.animation = { enabled: true, duration };

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).seriesTypeChange = seriesTypeChange;
  (<any>window).durationChange = durationChange;
}
```

[Live example: Duration](https://www.ag-grid.com/charts/archive/14.2.0/typescript/animation/examples/duration/)

To highlight data changes with a flash effect, see [Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/javascript/flash-on-update/).

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `true` to enable the animation module. Defaults to `false` when `flashOnUpdate.enabled` is `true`. |
| duration | DurationMs |  | The total duration of the animation on initial load and updates. |


---
product: "AG Charts"
title: "Animation"
description: "Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out."
enterprise: true
framework: react
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/touch/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Animation

## Initial Load

Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out.

#### Initial Load

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgCartesianSeriesTooltipRendererParams,
  AgChartOptions,
  AgPolarChartOptions,
  AgTooltipRendererResult,
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { DataType, getData } from "./data";
import clone from "clone";

const numFormatter = new Intl.NumberFormat("en-US");
const tooltip = {
  renderer: ({
    datum,
    yKey,
    yName,
  }: AgCartesianSeriesTooltipRendererParams<DataType>): AgTooltipRendererResult => {
    return {
      data: [
        { label: yName!, value: numFormatter.format(Number(datum[yKey])) },
      ],
    };
  },
};
const barOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "bar",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const lineOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "line",
      xKey: "station",
      yKey: "early",
      yName: "Early",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const areaOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "area",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const donutOptions: AgPolarChartOptions<DataType> = {
  series: [
    {
      type: "pie",
      title: {
        text: "Morning Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "morningPeak",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Afternoon Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "afternoonPeak",
      showInLegend: false,
    },
  ],
};
ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<
    AgCartesianChartOptions<DataType> | AgPolarChartOptions<DataType>
  >({
    data: getData(),
    animation: {
      enabled: true,
    },
    ...barOptions,
  });

  const seriesTypeChange = (event: Event) => {
    const nextOptions = clone(options);

    const value = (event.target as HTMLInputElement).value;
    const seriesOptions = {
      bar: barOptions,
      line: lineOptions,
      area: areaOptions,
      donut: donutOptions,
    }[value]!;
    nextOptions.series = seriesOptions.series;
    nextOptions.axes = seriesOptions.axes;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div className="button-group" role="group" aria-label="Series Type">
            <input
              type="radio"
              id="series-bar"
              name="series-type"
              defaultValue="bar"
              defaultChecked
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-bar">Bar</label>
            <input
              type="radio"
              id="series-line"
              name="series-type"
              defaultValue="line"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-line">Line</label>
            <input
              type="radio"
              id="series-area"
              name="series-type"
              defaultValue="area"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-area">Area</label>
            <input
              type="radio"
              id="series-donut"
              name="series-type"
              defaultValue="donut"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-donut">Pie &amp; Donut</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Initial Load](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/animation/examples/initial-load/)

## Data Updates

A data update animation is split into three sequential phases — remove, update then add, which can be observed for different series types in this example:

#### Line Series Data Updates

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgChartOptions,
  AgPolarChartOptions,
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { getData, random } from "./data";
import clone from "clone";

let start = [120, 150, 130, 140, 80];
let variance = 20;
let offset = 0;
let length = 8;
let seed = 1234;
const barOptions: AgCartesianChartOptions = {
  series: [
    {
      type: "bar",
      xKey: "year",
      yKey: "one",
      yName: "One",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "two",
      yName: "Two",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "three",
      yName: "Three",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "four",
      yName: "Four",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "five",
      yName: "Five",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        autoRotate: false,
      },
    },
  },
};
const lineOptions: AgCartesianChartOptions = {
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "one",
      yName: "One",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "two",
      yName: "Two",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "three",
      yName: "Three",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "four",
      yName: "Four",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "five",
      yName: "Five",
    },
  ],
  axes: {
    x: {
      type: "number",
      nice: false,
      label: {
        autoRotate: false,
      },
    },
  },
};
const areaOptions: AgCartesianChartOptions = {
  series: [
    {
      type: "area",
      xKey: "year",
      yKey: "one",
      yName: "One",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "two",
      yName: "Two",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "three",
      yName: "Three",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "four",
      yName: "Four",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "five",
      yName: "Five",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "number",
      nice: false,
      label: {
        autoRotate: false,
      },
    },
  },
};
const donutOptions: AgPolarChartOptions = {
  series: [
    {
      type: "pie",
      title: {
        text: "One",
      },
      calloutLabelKey: "year",
      legendItemKey: "year",
      angleKey: "one",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Two",
      },
      calloutLabelKey: "year",
      legendItemKey: "year",
      angleKey: "two",
      showInLegend: false,
    },
  ],
};
function getGeneratedData() {
  return getData(start, variance, offset, length, seed);
}
ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<
    AgCartesianChartOptions | AgPolarChartOptions
  >({
    animation: {
      enabled: true,
    },
    data: getGeneratedData(),
    ...barOptions,
  });

  const seriesTypeChange = (event: Event) => {
    const nextOptions = clone(options);

    const seriesType = (event.target as HTMLInputElement).value as
      | "bar"
      | "line"
      | "area"
      | "donut";
    offset = 0;
    seed = 1234;
    switch (seriesType) {
      case "bar":
        variance = 20;
        length = 8;
        nextOptions.series = barOptions.series;
        nextOptions.axes = barOptions.axes;
        break;
      case "line":
        variance = 4;
        length = 30;
        nextOptions.series = lineOptions.series;
        nextOptions.axes = lineOptions.axes;
        break;
      case "area":
        variance = 20;
        length = 30;
        nextOptions.series = areaOptions.series;
        nextOptions.axes = areaOptions.axes;
        break;
      case "donut":
        variance = 30;
        length = 6;
        nextOptions.series = donutOptions.series;
        nextOptions.axes = donutOptions.axes;
        break;
    }
    nextOptions.data = getGeneratedData();

    setOptions(nextOptions);
  };

  const add = () => {
    const nextOptions = clone(options);

    offset++;
    length++;
    nextOptions.data = getGeneratedData();

    setOptions(nextOptions);
  };

  const remove = () => {
    const nextOptions = clone(options);

    if (nextOptions.series?.[0].type === "pie") offset--;
    length = Math.max(0, length - 1);
    nextOptions.data = getGeneratedData();

    setOptions(nextOptions);
  };

  const update = () => {
    const nextOptions = clone(options);

    seed = Math.floor(random() * 1000);
    nextOptions.data = getGeneratedData();

    setOptions(nextOptions);
  };

  const addRemoveUpdate = () => {
    const nextOptions = clone(options);

    if (nextOptions.series?.[0].type === "pie") offset--;
    if (nextOptions.series?.[0].type !== "pie") offset++;
    seed = Math.floor(random() * 1000);
    nextOptions.data = getGeneratedData();

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group gap-right"
            role="group"
            aria-label="Series Type"
          >
            <input
              type="radio"
              id="series-bar"
              name="series-type"
              defaultValue="bar"
              defaultChecked
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-bar">Bar</label>
            <input
              type="radio"
              id="series-line"
              name="series-type"
              defaultValue="line"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-line">Line</label>
            <input
              type="radio"
              id="series-area"
              name="series-type"
              defaultValue="area"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-area">Area</label>
            <input
              type="radio"
              id="series-donut"
              name="series-type"
              defaultValue="donut"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-donut">Pie &amp; Donut</label>
          </div>
          <button className="animation-data-updates__action" onClick={add}>
            Add
          </button>
          <button className="animation-data-updates__action" onClick={remove}>
            Remove
          </button>
          <button
            className="animation-data-updates__action gap-right"
            onClick={update}
          >
            Update
          </button>
          <button
            className="animation-data-updates__action"
            onClick={addRemoveUpdate}
          >
            Add &amp; Remove &amp; Update
          </button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Line Series Data Updates](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/animation/examples/data-updates/)

## Duration

You can use the `duration` option to specify the length of all animations in milliseconds.

For an initial load, this is simply the duration of the whole animation.

For a data update, the duration is the total time of all three animation phases together — remove, update then add.

```js
{
    animation: {
        duration: 500,
    },
}
```

In this example, click a duration then change the series type to see the initial load animation.

#### Duration

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgCartesianSeriesTooltipRendererParams,
  AgChartOptions,
  AgPolarChartOptions,
  AgTooltipRendererResult,
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { DataType, getData } from "./data";
import clone from "clone";

const numFormatter = new Intl.NumberFormat("en-US");
const tooltip = {
  renderer: ({
    datum,
    yKey,
    yName,
  }: AgCartesianSeriesTooltipRendererParams<DataType>): AgTooltipRendererResult => {
    return {
      data: [
        { label: yName!, value: numFormatter.format(Number(datum[yKey])) },
      ],
    };
  },
};
const barOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "bar",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const lineOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "line",
      xKey: "station",
      yKey: "early",
      yName: "Early",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const areaOptions: AgCartesianChartOptions<DataType> = {
  series: [
    {
      type: "area",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};
const donutOptions: AgPolarChartOptions<DataType> = {
  series: [
    {
      type: "pie",
      title: {
        text: "Morning Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "morningPeak",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Afternoon Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "afternoonPeak",
      showInLegend: false,
    },
  ],
};
ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<
    AgCartesianChartOptions<DataType> | AgPolarChartOptions<DataType>
  >({
    data: getData(),
    animation: {
      enabled: true,
      duration: 500,
    },
    ...barOptions,
  });

  const seriesTypeChange = (event: Event) => {
    const nextOptions = clone(options);

    const value = (event.target as HTMLInputElement).value;
    switch (value) {
      case "bar":
        nextOptions.series = barOptions.series;
        nextOptions.axes = barOptions.axes;
        break;
      case "line":
        nextOptions.series = lineOptions.series;
        nextOptions.axes = lineOptions.axes;
        break;
      case "area":
        nextOptions.series = areaOptions.series;
        nextOptions.axes = areaOptions.axes;
        break;
      case "donut":
        nextOptions.series = donutOptions.series;
        nextOptions.axes = donutOptions.axes;
        break;
    }

    setOptions(nextOptions);
  };

  const durationChange = (event: Event) => {
    const nextOptions = clone(options);

    const duration = Number((event.target as HTMLInputElement).value);
    nextOptions.animation = { enabled: true, duration };

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group gap-right"
            role="group"
            aria-label="Series Type"
          >
            <input
              type="radio"
              id="series-bar"
              name="series-type"
              defaultValue="bar"
              defaultChecked
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-bar">Bar</label>
            <input
              type="radio"
              id="series-line"
              name="series-type"
              defaultValue="line"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-line">Line</label>
            <input
              type="radio"
              id="series-area"
              name="series-type"
              defaultValue="area"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-area">Area</label>
            <input
              type="radio"
              id="series-donut"
              name="series-type"
              defaultValue="donut"
              onChange={(event) => seriesTypeChange(event)}
            />
            <label htmlFor="series-donut">Pie &amp; Donut</label>
          </div>
          <div
            className="button-group"
            role="group"
            aria-label="Animation Duration"
          >
            <input
              type="radio"
              id="duration-500"
              name="animation-duration"
              defaultValue="500"
              defaultChecked
              onChange={(event) => durationChange(event)}
            />
            <label htmlFor="duration-500">Duration: 500ms</label>
            <input
              type="radio"
              id="duration-2000"
              name="animation-duration"
              defaultValue="2000"
              onChange={(event) => durationChange(event)}
            />
            <label htmlFor="duration-2000">Duration: 2000ms</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Duration](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/animation/examples/duration/)

To highlight data changes with a flash effect, see [Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/react/flash-on-update/).

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `true` to enable the animation module. Defaults to `false` when `flashOnUpdate.enabled` is `true`. |
| duration | DurationMs |  | The total duration of the animation on initial load and updates. |


---
product: "AG Charts"
title: "Animation"
description: "Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out."
enterprise: true
framework: vue
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/touch/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Animation

## Initial Load

Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out.

#### Initial Load

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

const numFormatter = new Intl.NumberFormat("en-US");

const tooltip = {
  renderer: ({ datum, yKey, yName }) => {
    return {
      data: [{ label: yName, value: numFormatter.format(Number(datum[yKey])) }],
    };
  },
};

const barOptions = {
  series: [
    {
      type: "bar",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};

const lineOptions = {
  series: [
    {
      type: "line",
      xKey: "station",
      yKey: "early",
      yName: "Early",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};

const areaOptions = {
  series: [
    {
      type: "area",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        wrapping: "on-space",
        autoRotate: false,
      },
    },
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};

const donutOptions = {
  series: [
    {
      type: "pie",
      title: {
        text: "Morning Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "morningPeak",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Afternoon Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "afternoonPeak",
      showInLegend: false,
    },
  ],
};

ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Series Type">
          <input type="radio" id="series-bar" name="series-type" value="bar" checked="" v-on:change="seriesTypeChange($event)">
            <label for="series-bar">Bar</label>
            <input type="radio" id="series-line" name="series-type" value="line" v-on:change="seriesTypeChange($event)">
              <label for="series-line">Line</label>
              <input type="radio" id="series-area" name="series-type" value="area" v-on:change="seriesTypeChange($event)">
                <label for="series-area">Area</label>
                <input type="radio" id="series-donut" name="series-type" value="donut" v-on:change="seriesTypeChange($event)">
                  <label for="series-donut">Pie &amp; Donut</label>
                </div>
              </div>
            </div>
            <ag-charts
              :options="options"
            />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<
      AgCartesianChartOptions<DataType> | AgPolarChartOptions<DataType>
    >({
      data: getData(),
      animation: {
        enabled: true,
      },
      ...barOptions,
    });

    const seriesTypeChange = (event) => {
      const optionsCopy = clone(options.value);

      const value = event.target.value;
      const seriesOptions = {
        bar: barOptions,
        line: lineOptions,
        area: areaOptions,
        donut: donutOptions,
      }[value];
      optionsCopy.series = seriesOptions.series;
      optionsCopy.axes = seriesOptions.axes;

      options.value = optionsCopy;
    };

    return {
      options,
      seriesTypeChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Initial Load](https://www.ag-grid.com/charts/archive/14.2.0/vue3/animation/examples/initial-load/)

## Data Updates

A data update animation is split into three sequential phases — remove, update then add, which can be observed for different series types in this example:

#### Line Series Data Updates

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { getData, random } from "./data";
import clone from "clone";

let start = [120, 150, 130, 140, 80];

let variance = 20;

let offset = 0;

let length = 8;

let seed = 1234;

const barOptions = {
  series: [
    {
      type: "bar",
      xKey: "year",
      yKey: "one",
      yName: "One",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "two",
      yName: "Two",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "three",
      yName: "Three",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "four",
      yName: "Four",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "five",
      yName: "Five",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "category",
      label: {
        autoRotate: false,
      },
    },
  },
};

const lineOptions = {
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "one",
      yName: "One",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "two",
      yName: "Two",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "three",
      yName: "Three",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "four",
      yName: "Four",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "five",
      yName: "Five",
    },
  ],
  axes: {
    x: {
      type: "number",
      nice: false,
      label: {
        autoRotate: false,
      },
    },
  },
};

const areaOptions = {
  series: [
    {
      type: "area",
      xKey: "year",
      yKey: "one",
      yName: "One",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "two",
      yName: "Two",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "three",
      yName: "Three",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "four",
      yName: "Four",
      stacked: true,
    },
    {
      type: "area",
      xKey: "year",
      yKey: "five",
      yName: "Five",
      stacked: true,
    },
  ],
  axes: {
    x: {
      type: "number",
      nice: false,
      label: {
        autoRotate: false,
      },
    },
  },
};

const donutOptions = {
  series: [
    {
      type: "pie",
      title: {
        text: "One",
      },
      calloutLabelKey: "year",
      legendItemKey: "year",
      angleKey: "one",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Two",
      },
      calloutLabelKey: "year",
      legendItemKey: "year",
      angleKey: "two",
      showInLegend: false,
    },
  ],
};

function getGeneratedData() {
  return getData(start, variance, offset, length, seed);
}

ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group gap-right" role="group" aria-label="Series Type">
          <input type="radio" id="series-bar" name="series-type" value="bar" checked="" v-on:change="seriesTypeChange($event)">
            <label for="series-bar">Bar</label>
            <input type="radio" id="series-line" name="series-type" value="line" v-on:change="seriesTypeChange($event)">
              <label for="series-line">Line</label>
              <input type="radio" id="series-area" name="series-type" value="area" v-on:change="seriesTypeChange($event)">
                <label for="series-area">Area</label>
                <input type="radio" id="series-donut" name="series-type" value="donut" v-on:change="seriesTypeChange($event)">
                  <label for="series-donut">Pie &amp; Donut</label>
                </div>
                <button class="animation-data-updates__action" v-on:click="add()">Add</button>
                <button class="animation-data-updates__action" v-on:click="remove()">Remove</button>
                <button class="animation-data-updates__action gap-right" v-on:click="update()">Update</button>
                <button class="animation-data-updates__action" v-on:click="addRemoveUpdate()">Add &amp; Remove &amp; Update</button>
              </div>
            </div>
            <ag-charts
              :options="options"
            />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions | AgPolarChartOptions>({
      animation: {
        enabled: true,
      },
      data: getGeneratedData(),
      ...barOptions,
    });

    const seriesTypeChange = (event) => {
      const optionsCopy = clone(options.value);

      const seriesType = event.target.value;
      offset = 0;
      seed = 1234;
      switch (seriesType) {
        case "bar":
          variance = 20;
          length = 8;
          optionsCopy.series = barOptions.series;
          optionsCopy.axes = barOptions.axes;
          break;
        case "line":
          variance = 4;
          length = 30;
          optionsCopy.series = lineOptions.series;
          optionsCopy.axes = lineOptions.axes;
          break;
        case "area":
          variance = 20;
          length = 30;
          optionsCopy.series = areaOptions.series;
          optionsCopy.axes = areaOptions.axes;
          break;
        case "donut":
          variance = 30;
          length = 6;
          optionsCopy.series = donutOptions.series;
          optionsCopy.axes = donutOptions.axes;
          break;
      }
      optionsCopy.data = getGeneratedData();

      options.value = optionsCopy;
    };
    const add = () => {
      const optionsCopy = clone(options.value);

      offset++;
      length++;
      optionsCopy.data = getGeneratedData();

      options.value = optionsCopy;
    };
    const remove = () => {
      const optionsCopy = clone(options.value);

      if (optionsCopy.series?.[0].type === "pie") offset--;
      length = Math.max(0, length - 1);
      optionsCopy.data = getGeneratedData();

      options.value = optionsCopy;
    };
    const update = () => {
      const optionsCopy = clone(options.value);

      seed = Math.floor(random() * 1000);
      optionsCopy.data = getGeneratedData();

      options.value = optionsCopy;
    };
    const addRemoveUpdate = () => {
      const optionsCopy = clone(options.value);

      if (optionsCopy.series?.[0].type === "pie") offset--;
      if (optionsCopy.series?.[0].type !== "pie") offset++;
      seed = Math.floor(random() * 1000);
      optionsCopy.data = getGeneratedData();

      options.value = optionsCopy;
    };

    return {
      options,
      seriesTypeChange,
      add,
      remove,
      update,
      addRemoveUpdate,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Line Series Data Updates](https://www.ag-grid.com/charts/archive/14.2.0/vue3/animation/examples/data-updates/)

## Duration

You can use the `duration` option to specify the length of all animations in milliseconds.

For an initial load, this is simply the duration of the whole animation.

For a data update, the duration is the total time of all three animation phases together — remove, update then add.

```js
{
    animation: {
        duration: 500,
    },
}
```

In this example, click a duration then change the series type to see the initial load animation.

#### Duration

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  PieSeriesModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

const numFormatter = new Intl.NumberFormat("en-US");

const tooltip = {
  renderer: ({ datum, yKey, yName }) => {
    return {
      data: [{ label: yName, value: numFormatter.format(Number(datum[yKey])) }],
    };
  },
};

const barOptions = {
  series: [
    {
      type: "bar",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "bar",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};

const lineOptions = {
  series: [
    {
      type: "line",
      xKey: "station",
      yKey: "early",
      yName: "Early",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      tooltip,
    },
    {
      type: "line",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};

const areaOptions = {
  series: [
    {
      type: "area",
      xKey: "station",
      yKey: "early",
      stacked: true,
      yName: "Early",
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "morningPeak",
      yName: "Morning peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "interPeak",
      yName: "Between peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "afternoonPeak",
      yName: "Afternoon peak",
      stacked: true,
      tooltip,
    },
    {
      type: "area",
      xKey: "station",
      yKey: "evening",
      yName: "Evening",
      stacked: true,
      tooltip,
    },
  ],
  axes: {
    y: {
      type: "number",
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
};

const donutOptions = {
  series: [
    {
      type: "pie",
      title: {
        text: "Morning Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "morningPeak",
      outerRadiusRatio: 0.6,
    },
    {
      type: "donut",
      title: {
        text: "Afternoon Peak",
      },
      calloutLabelKey: "station",
      legendItemKey: "station",
      angleKey: "afternoonPeak",
      showInLegend: false,
    },
  ],
};

ModuleRegistry.registerModules([
  AnimationModule,
  AreaSeriesModule,
  BarSeriesModule,
  CategoryAxisModule,
  CrosshairModule,
  DonutSeriesModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  PieSeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group gap-right" role="group" aria-label="Series Type">
          <input type="radio" id="series-bar" name="series-type" value="bar" checked="" v-on:change="seriesTypeChange($event)">
            <label for="series-bar">Bar</label>
            <input type="radio" id="series-line" name="series-type" value="line" v-on:change="seriesTypeChange($event)">
              <label for="series-line">Line</label>
              <input type="radio" id="series-area" name="series-type" value="area" v-on:change="seriesTypeChange($event)">
                <label for="series-area">Area</label>
                <input type="radio" id="series-donut" name="series-type" value="donut" v-on:change="seriesTypeChange($event)">
                  <label for="series-donut">Pie &amp; Donut</label>
                </div>
                <div class="button-group" role="group" aria-label="Animation Duration">
                  <input type="radio" id="duration-500" name="animation-duration" value="500" checked="" v-on:change="durationChange($event)">
                    <label for="duration-500">Duration: 500ms</label>
                    <input type="radio" id="duration-2000" name="animation-duration" value="2000" v-on:change="durationChange($event)">
                      <label for="duration-2000">Duration: 2000ms</label>
                    </div>
                  </div>
                </div>
                <ag-charts
                  :options="options"
                />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<
      AgCartesianChartOptions<DataType> | AgPolarChartOptions<DataType>
    >({
      data: getData(),
      animation: {
        enabled: true,
        duration: 500,
      },
      ...barOptions,
    });

    const seriesTypeChange = (event) => {
      const optionsCopy = clone(options.value);

      const value = event.target.value;
      switch (value) {
        case "bar":
          optionsCopy.series = barOptions.series;
          optionsCopy.axes = barOptions.axes;
          break;
        case "line":
          optionsCopy.series = lineOptions.series;
          optionsCopy.axes = lineOptions.axes;
          break;
        case "area":
          optionsCopy.series = areaOptions.series;
          optionsCopy.axes = areaOptions.axes;
          break;
        case "donut":
          optionsCopy.series = donutOptions.series;
          optionsCopy.axes = donutOptions.axes;
          break;
      }

      options.value = optionsCopy;
    };
    const durationChange = (event) => {
      const optionsCopy = clone(options.value);

      const duration = Number(event.target.value);
      optionsCopy.animation = { enabled: true, duration };

      options.value = optionsCopy;
    };

    return {
      options,
      seriesTypeChange,
      durationChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Duration](https://www.ag-grid.com/charts/archive/14.2.0/vue3/animation/examples/duration/)

To highlight data changes with a flash effect, see [Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/vue/flash-on-update/).

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `true` to enable the animation module. Defaults to `false` when `flashOnUpdate.enabled` is `true`. |
| duration | DurationMs |  | The total duration of the animation on initial load and updates. |


---
product: "AG Charts"
title: "Animation"
description: "Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out."
enterprise: true
framework: angular
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/touch/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Animation

## Initial Load

Switch between the different series types below to see their initial load animations. Toggling items in the legend will also animate the series in and out.

#### Initial Load

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Initial Load](https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/examples/initial-load/)

## Data Updates

A data update animation is split into three sequential phases — remove, update then add, which can be observed for different series types in this example:

#### Line Series Data Updates

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Line Series Data Updates](https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/examples/data-updates/)

## Duration

You can use the `duration` option to specify the length of all animations in milliseconds.

For an initial load, this is simply the duration of the whole animation.

For a data update, the duration is the total time of all three animation phases together — remove, update then add.

```js
{
    animation: {
        duration: 500,
    },
}
```

In this example, click a duration then change the series type to see the initial load animation.

#### Duration

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Duration](https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/examples/duration/)

To highlight data changes with a flash effect, see [Flash On Update](https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/).

## API Reference

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `true` to enable the animation module. Defaults to `false` when `flashOnUpdate.enabled` is `true`. |
| duration | DurationMs |  | The total duration of the animation on initial load and updates. |
